create function set_variable(name name, value anyelement) returns anyelement
    language plpgsql
    security definer -- to be able to access omni_var
as
$$
begin
    raise warning 'omni_txn.set_variable is deprecated, use omni_var.set';
    return omni_var.set(name, value);
end
$$;

create function get_variable(name name, default_value anyelement) returns anyelement
    language plpgsql
    security definer -- to be able to access omni_var
    stable as
$$
begin
    raise warning 'omni_txn.get_variable is deprecated, use omni_var.get';
    return omni_var.get(name, default_value);
end
$$;
create procedure retry(stmts text, max_attempts int default 10, repeatable_read boolean default false,
                       collect_backoff_values boolean default false)
    language c as
'MODULE_PATHNAME';

comment on procedure retry is $$
Retry serializable transaction on statements `stmts`, `max_attempt` number of times (10 by default). `collect_backoff_values` controls if the backoff values used for sleeping will be recorded for debugging/testing purposes (false in orded to increase performance)
$$;

create function current_retry_attempt()
    returns int
    language c as
'MODULE_PATHNAME';

comment on function current_retry_attempt() is $$
Within `omni_txn.retry` indicates the current retry attempt. Zero during the first run.
$$;

create function retry_backoff_values()
    returns table
            (
              backoff_sleep_time int
            )
    volatile
    language c
as
'MODULE_PATHNAME';

comment on function retry_backoff_values () is $$
Retrieves the backoff values used in the `omni_txn.retry` run. Empty in the first run.
$$;

drop procedure retry(stmts text, max_attempts int, repeatable_read boolean,
                     collect_backoff_values boolean);

create procedure retry(stmts text, max_attempts int default 10, repeatable_read boolean default false,
                       collect_backoff_values boolean default false,
                       params record default null::record)
    language c as
'MODULE_PATHNAME';

comment on procedure retry is $$
Retry serializable transaction on statements `stmts`, `max_attempt` number of times (10 by default). `collect_backoff_values` controls if the backoff values used for sleeping will be recorded for debugging/testing purposes (false in orded to increase performance)
$$;
create function retry_prepared_statements()
    returns table
            (
                stmt text
            )
    language c
as
'MODULE_PATHNAME';

create view retry_prepared_statements as
select *
from retry_prepared_statements();

create function reset_retry_prepared_statements() returns void
    language c as
'MODULE_PATHNAME';
create function linearize() returns void
    language c
as
'MODULE_PATHNAME';

create function linearized() returns boolean
    language c
as
'MODULE_PATHNAME';

drop procedure retry(stmts text, max_attempts int, repeatable_read boolean,
                     collect_backoff_values boolean, params record);

create procedure retry(stmts text, max_attempts int default 10, repeatable_read boolean default false,
                       collect_backoff_values boolean default false,
                       params record default null::record, linearize boolean default false)
    language c as
'MODULE_PATHNAME';

drop function set_variable;
drop function get_variable;
